/*
 * LogEntryParser_LogfileLWI.h
 *
 *  Created on: Dec 18, 2011
 *      Author: sven
 */

#ifndef LogEntryParser_LogfileLWI_H_
#define LogEntryParser_LogfileLWI_H_
#include <QtCore/QtCore>

#include "LogData/LogEntryParser.h"

/**
 * This parser is used to read the previously generated log file. This file is
 * generated by the LogEntryTableModel using the exportToFile method.
 */
class LogEntryParser_LogfileLWI
: public QThread
//, public LogFileParser
, public LogEntryParser
{
    Q_OBJECT
public:
    LogEntryParser_LogfileLWI( const QString &filename );

    ~LogEntryParser_LogfileLWI();

    void startEmiting();

    void run();

    bool initParser();

    virtual std::shared_ptr<LogEntryParserModelConfiguration> getParserModelConfiguration() const;

signals:
    void newEntry( TconstSharedNewLogEntryMessage );

    void signalError( QString error );

    void finished();

private:

    TSharedLogEntry logEntryFromString( const QString &str);

    virtual TSharedLogEntry getNextLogEntry();

    bool m_abort;

    QFile m_logfile;

    QTextStream m_logfileStream;

    bool m_logfileStreamReady;

    QString m_stashedLine;

    std::shared_ptr<LogEntryFactory> m_factory;

    std::shared_ptr<LogEntryParserModelConfiguration> m_myModelConfig;

    int m_logEntryNumber;

    std::vector<int> m_order;
};

#endif /* LogEntryParser_LogfileLWI_H_ */
